name: Release

on:
  push:
    tags: ['v*']

permissions:
  contents: write

jobs:
  release:
    name: Create Release
    runs-on: ubuntu-latest

    steps:
      - name: Checkout
        uses: actions/checkout@v4
        with:
          fetch-depth: 0

      - name: Validate version tag
        run: |
          if ! [[ "${{ github.ref_name }}" =~ ^v[0-9]+\.[0-9]+\.[0-9]+$ ]]; then
            echo "Invalid version tag format. Expected vX.Y.Z"
            exit 1
          fi

      - name: Verify plugin.json version matches tag
        env:
          TAG_NAME: ${{ github.ref_name }}
        run: |
          TAG_VERSION="${TAG_NAME#v}"
          PLUGIN_VERSION=$(grep -oE '"version": *"[^"]*"' .claude-plugin/plugin.json | grep -oE '[0-9]+\.[0-9]+\.[0-9]+')
          if [ "$TAG_VERSION" != "$PLUGIN_VERSION" ]; then
            echo "::error::Tag version ($TAG_VERSION) does not match plugin.json version ($PLUGIN_VERSION)"
            echo "Run: ./scripts/release.sh $TAG_VERSION"
            exit 1
          fi

      - name: Generate release highlights
        id: highlights
        env:
          TAG_NAME: ${{ github.ref_name }}
        run: |
          TAG_VERSION="${TAG_NAME#v}"
          cat > release_body.md <<EOF
          ## ECC ${TAG_VERSION}

          ### What This Release Focuses On
          - Harness reliability and hook stability across Claude Code, Cursor, OpenCode, and Codex
          - Stronger eval-driven workflows and quality gates
          - Better operator UX for autonomous loop execution

          ### Notable Changes
          - Session persistence and hook lifecycle fixes
          - Expanded skills and command coverage for harness performance work
          - Improved release-note generation and changelog hygiene

          ### Notes
          - For migration tips and compatibility notes, see README and CHANGELOG.
          EOF

      - name: Create GitHub Release
        uses: softprops/action-gh-release@v2
        with:
          body_path: release_body.md
          generate_release_notes: true
